#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

# This script can be used to delete categories with their links from 
# Telnet or SSH. It is invoked as follows:
#
# ldel.cgi 123
#
# where in the above example 123 is the category ID of the category
# that is to be deleted.


#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi";

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

#acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################


if ($ARGV[0] ne "")
	{

	
	if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
	$dbh = DBI->connect($dsn, $db_username, $db_password);
	if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
	
	
	@delitems = split(/,/,$ARGV[0]);
	
	foreach $dditem (@delitems)
	{
	
	$sql = "SELECT * FROM dirs WHERE cid = '$dditem'";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

	$sql_strin = "";
	while ( @row = $sth->fetchrow() )
		{
			
			$cc = 1;
			for ($ms = 2; $ms < 18; $ms++) 
					{
					if ($row[$ms] ne "")
						{
						$sql_strin = $sql_strin . "l" .  $cc . " = '$row[$ms]' AND ";
						$cc++;
						}
					}
		
		}
		
		chop($sql_strin);chop($sql_strin);chop($sql_strin);chop($sql_strin);
		

	$sql = "SELECT cid FROM dirs WHERE $sql_strin";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	$rows = $sth->rows(); 

   my (@arr_cid);
	$aa=0;
	while ( @row = $sth->fetchrow() )
		{
		push (@arr_cid, $row[0]);

		print "Selecting: $aa of $rows\n";
		$aa++;
		}



$itemtotal = @arr_cid;



#######################################


$itemcc = 0; $gloc = 1;
foreach $item (@arr_cid)
	{
	$ddids = $ddids . "$item,";
	
	if ($itemcc == 50)
		{
		$itemcc = 0;

			print "Deleting From Links... $gloc of $itemtotal\n\n";
			
			chop($ddids);
			$sql = "DELETE FROM links WHERE cid IN ($ddids)";
			$sth = $dbh->prepare($sql);
			$sth->execute;
			$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
		}
	
	
	$itemcc++;
	$gloc++;
	}



if ($itemcc > 0)
	{
		print "Deleting From Links... $gloc of $itemtotal\n\n";
		chop($ddids);
		$sql = "DELETE FROM links WHERE cid IN ($ddids)";
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	}
	



####################### DELETE DIRS

$c = 1;
foreach $item (@arr_cid)
	{
	$sql = "DELETE FROM dirs WHERE cid = '$item'";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	
	print "Deleting Dirs: $item - $c of $itemtotal\n\n";
	$c++;
	}



}



}

$sth->finish;
$dbh->disconnect;
	





####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

